
#include "config.h"
#include "sequencer.h"
#include <LCDMenuLib2.h>
#include <LiquidCrystal_I2C.h>

extern LCDMenuLib2 LCDML;
extern LiquidCrystal_I2C lcd;
extern config_t configuration;
extern void handleNoteOn(byte , byte , byte );
extern void handleNoteOff(byte , byte , byte );
extern void UI_func_sequencer(uint8_t);
extern const char* seq_find_shortname(uint8_t);

void sequencer(void)
{
  //if (seq_note_in > 0 && seq_note_in < 62 && seq_recording == false ) {
  //handleNoteOff(configuration.dexed[0].midi_channel, seq_data[3][seq_step] + seq_transpose , 0);
  //handleNoteOff(configuration.dexed[0].midi_channel, seq_data[3][seq_step - 1] + seq_transpose , 0);
  //if (seq_note_in>65)seq_note_in=seq_note_in-12;
  //seq_transpose = seq_note_in % 12 ;
  //seq_transpose=seq_transpose-12;
  //seq_note_in = 0;
  //}

  if (seq_millis_timer  > seq_timer_previous + seq_tempo_ms)
  {
    seq_timer_previous = seq_millis_timer;

    if (LCDML.FUNC_getID() == LCDML.OTHER_getIDFromFunction(UI_func_sequencer)) {

      //write to sequencer if in sequencer menu
      if (seq_note_in > 0 && seq_recording == true) {

        //  if (  seq_content_type[ seq_patternchain[seq_chain_active_step][active_track]  ] == 1) handleNoteOff(configuration.dexed[0].midi_channel, seq_data[active_track][seq_step] + seq_transpose , 0);

        seq_data[seq_active_track][seq_step] = seq_note_in;
        seq_vel[seq_active_track][seq_step] = seq_note_in_velocity;
        seq_note_in = 0;
        seq_note_in_velocity = 0;
      }
      lcd.setCursor(seq_step, 1);
      lcd.print("X");
      if (seq_step == 0) {
        lcd.setCursor(15, 1);
        lcd.print(seq_find_shortname(15)[0]);
      }
      else
      {
        lcd.setCursor(seq_step - 1, 1);
        lcd.print(seq_find_shortname(seq_step - 1)[0]);
      }
    }

    for (uint8_t d = 0; d < 4; d++)
    {
      if ( seq_track_type[d] == 0) { // drum track
        if (seq_data[ seq_patternchain[seq_chain_active_step][d] ][seq_step] > 0 && seq_vel[ seq_patternchain[seq_chain_active_step][d] ][seq_step] > 0)
        {
          handleNoteOn(DRUM_MIDI_CHANNEL, seq_data[ seq_patternchain[seq_chain_active_step][d] ][seq_step] , seq_vel[ seq_patternchain[seq_chain_active_step][d] ][seq_step]);
        }
      }
      else {
        if (seq_data[ seq_patternchain[seq_chain_active_step][d] ][seq_step] > 0 && seq_vel[ seq_patternchain[seq_chain_active_step][d] ][seq_step] > 0)  // instrument track
        {
          handleNoteOn(configuration.dexed[seq_inst_dexed[d]].midi_channel, seq_data[ seq_patternchain[seq_chain_active_step][d] ][seq_step] + seq_transpose , seq_vel[ seq_patternchain[seq_chain_active_step][d] ][seq_step]);
          seq_prev_note[d] = seq_data[ seq_patternchain[seq_chain_active_step][d] ][seq_step] + seq_transpose;
          seq_prev_vel[d] = seq_vel[ seq_patternchain[seq_chain_active_step][d] ][seq_step];
          if (seq_track_type[d] == 2) {
            if (seq_vel[ seq_patternchain[seq_chain_active_step][d] ][seq_step] > 199)
            {
              handleNoteOn(configuration.dexed[seq_chord_ch].midi_channel, seq_data[ seq_patternchain[seq_chain_active_step][d] ][seq_step] + seq_transpose + seq_chords[seq_vel[ seq_patternchain[seq_chain_active_step][d] ][seq_step] - 200][0], seq_chord_velocity);
              handleNoteOn(configuration.dexed[seq_chord_ch].midi_channel, seq_data[ seq_patternchain[seq_chain_active_step][d] ][seq_step] + seq_transpose + seq_chords[seq_vel[ seq_patternchain[seq_chain_active_step][d] ][seq_step] - 200][1], seq_chord_velocity);
              handleNoteOn(configuration.dexed[seq_chord_ch].midi_channel, seq_data[ seq_patternchain[seq_chain_active_step][d] ][seq_step] + seq_transpose + seq_chords[seq_vel[ seq_patternchain[seq_chain_active_step][d] ][seq_step] - 200][2], seq_chord_velocity);
              handleNoteOn(configuration.dexed[seq_chord_ch].midi_channel, seq_data[ seq_patternchain[seq_chain_active_step][d] ][seq_step] + seq_transpose + seq_chords[seq_vel[ seq_patternchain[seq_chain_active_step][d] ][seq_step] - 200][3], seq_chord_velocity);
            }
          }
        }
      }
      seq_noteoffsent[d] = false;
    }

    seq_step++;

    if (seq_step > 15) {
      seq_step = 0;
      if (seq_chain_lenght > 0) {
        seq_chain_active_step++;
        if (seq_chain_active_step > seq_chain_lenght)
        {
          seq_chain_active_step = 0;
        }
      }
    }
  }
  if (seq_millis_timer > seq_timer_previous + 80 )
  {
    for (uint8_t d = 0; d < 4; d++)
    {
      if ( seq_noteoffsent[d] == false) {
        if ( seq_prev_note[d] > 0 && seq_track_type[d] > 0)  //test instrument sequencer Instance=0
        {
          handleNoteOff(configuration.dexed[seq_inst_dexed[d]].midi_channel, seq_prev_note[d] , 0);
          if (seq_track_type[d] == 2) {
            if ( seq_prev_vel[d]  > 199)  {

              handleNoteOff(configuration.dexed[seq_chord_ch].midi_channel, seq_prev_note[d] + seq_chords[seq_prev_vel[d] - 200][0], 0);
              handleNoteOff(configuration.dexed[seq_chord_ch].midi_channel, seq_prev_note[d] + seq_chords[seq_prev_vel[d] - 200][1] , 0);
              handleNoteOff(configuration.dexed[seq_chord_ch].midi_channel, seq_prev_note[d] + seq_chords[seq_prev_vel[d] - 200][2] , 0);
              handleNoteOff(configuration.dexed[seq_chord_ch].midi_channel, seq_prev_note[d] + seq_chords[seq_prev_vel[d] - 200][3] , 0);
            }

          }
        }
      }
      seq_noteoffsent[d] = true;
    }
  }
}
